module Fedi.Helpers
  ( module Export
  , module Fedi.Helpers
  )
where

import Fedi.UserDetails
import Data.Foldable as Export
import Data.Maybe as Export (fromMaybe, listToMaybe, maybeToList)
import Data.String as Export (fromString)
import Data.Text as Export (Text)
import Data.ByteString as Export (ByteString)
import Data.Time as Export (UTCTime)
import Data.Traversable as Export
import GHC.Generics as Export (Generic)
import Control.Monad as Export
import Data.Functor as Export
import Data.Function as Export
import Control.Monad.Catch as Export (throwM, Exception, MonadThrow)
import Text.Pretty.Simple qualified as PS
import Data.Text.Lazy qualified as TL

data Error
  = Error String
  deriving (Show, Exception)

throw :: MonadThrow m => String -> m a
throw = throwM . Error

pShow :: Show a => a -> Text
pShow = TL.toStrict . PS.pShow
